]> git.ipfire.org Git - thirdparty/git.git/blame - git-stash.sh
git-merge: no reason to use cpio anymore
[thirdparty/git.git] / git-stash.sh
CommitLineData
f2c66ed1
NS
1#!/bin/sh
2# Copyright (c) 2007, Nanako Shiraishi
3
4USAGE='[ | list | show | apply | clear]'
5
3cd2491a 6SUBDIRECTORY_OK=Yes
f2c66ed1
NS
7. git-sh-setup
8require_work_tree
ceff079b 9cd_to_toplevel
f2c66ed1
NS
10
11TMP="$GIT_DIR/.git-stash.$$"
12trap 'rm -f "$TMP-*"' 0
13
14ref_stash=refs/stash
15
16no_changes () {
5be60078
JH
17 git diff-index --quiet --cached HEAD &&
18 git diff-files --quiet
f2c66ed1
NS
19}
20
21clear_stash () {
7ab3cc70
JH
22 if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
23 then
24 git update-ref -d refs/stash $current
25 fi
f2c66ed1
NS
26}
27
bc9e7399 28create_stash () {
9f62e18a
JH
29 stash_msg="$1"
30
f2c66ed1
NS
31 if no_changes
32 then
f2c66ed1
NS
33 exit 0
34 fi
f12e925a 35
f2c66ed1 36 # state of the base commit
5be60078 37 if b_commit=$(git rev-parse --verify HEAD)
f2c66ed1 38 then
5be60078 39 head=$(git log --abbrev-commit --pretty=oneline -n 1 HEAD)
f2c66ed1
NS
40 else
41 die "You do not have the initial commit yet"
42 fi
43
5be60078 44 if branch=$(git symbolic-ref -q HEAD)
f2c66ed1
NS
45 then
46 branch=${branch#refs/heads/}
47 else
48 branch='(no branch)'
49 fi
50 msg=$(printf '%s: %s' "$branch" "$head")
51
52 # state of the index
5be60078 53 i_tree=$(git write-tree) &&
6143fa2c 54 i_commit=$(printf 'index on %s\n' "$msg" |
5be60078 55 git commit-tree $i_tree -p $b_commit) ||
f2c66ed1
NS
56 die "Cannot save the current index state"
57
58 # state of the working tree
59 w_tree=$( (
b24f56d6
JH
60 rm -f "$TMP-index" &&
61 cp -p ${GIT_INDEX_FILE-"$GIT_DIR/index"} "$TMP-index" &&
f2c66ed1
NS
62 GIT_INDEX_FILE="$TMP-index" &&
63 export GIT_INDEX_FILE &&
b24f56d6 64 git read-tree -m $i_tree &&
5be60078
JH
65 git add -u &&
66 git write-tree &&
f2c66ed1
NS
67 rm -f "$TMP-index"
68 ) ) ||
69 die "Cannot save the current worktree state"
70
71 # create the stash
9f62e18a
JH
72 if test -z "$stash_msg"
73 then
74 stash_msg=$(printf 'WIP on %s' "$msg")
75 else
76 stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
77 fi
78 w_commit=$(printf '%s\n' "$stash_msg" |
5be60078 79 git commit-tree $w_tree -p $b_commit -p $i_commit) ||
f2c66ed1 80 die "Cannot record working tree state"
bc9e7399 81}
f2c66ed1 82
bc9e7399
JH
83save_stash () {
84 stash_msg="$1"
85
86 if no_changes
87 then
88 echo >&2 'No local changes to save'
89 exit 0
90 fi
91 test -f "$GIT_DIR/logs/$ref_stash" ||
92 clear_stash || die "Cannot initialize stash"
93
94 create_stash "$stash_msg"
9f62e18a 95 git update-ref -m "$stash_msg" $ref_stash $w_commit ||
f2c66ed1 96 die "Cannot save the current status"
9f62e18a 97 printf >&2 'Saved "%s"\n' "$stash_msg"
f2c66ed1
NS
98}
99
401de405 100have_stash () {
5be60078 101 git rev-parse --verify $ref_stash >/dev/null 2>&1
401de405
JK
102}
103
f2c66ed1 104list_stash () {
401de405 105 have_stash || return 0
5be60078 106 git log --pretty=oneline -g "$@" $ref_stash |
f2c66ed1
NS
107 sed -n -e 's/^[.0-9a-f]* refs\///p'
108}
109
110show_stash () {
5be60078 111 flags=$(git rev-parse --no-revs --flags "$@")
f2c66ed1
NS
112 if test -z "$flags"
113 then
114 flags=--stat
115 fi
5be60078 116 s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@")
f2c66ed1 117
5be60078
JH
118 w_commit=$(git rev-parse --verify "$s") &&
119 b_commit=$(git rev-parse --verify "$s^") &&
120 git diff $flags $b_commit $w_commit
f2c66ed1
NS
121}
122
123apply_stash () {
5be60078 124 git diff-files --quiet ||
f2c66ed1
NS
125 die 'Cannot restore on top of a dirty state'
126
150937c4
JS
127 unstash_index=
128 case "$1" in
129 --index)
130 unstash_index=t
131 shift
132 esac
133
f2c66ed1 134 # current index state
5be60078 135 c_tree=$(git write-tree) ||
f2c66ed1
NS
136 die 'Cannot apply a stash in the middle of a merge'
137
cbeaccc3
JH
138 # stash records the work tree, and is a merge between the
139 # base commit (first parent) and the index tree (second parent).
5be60078
JH
140 s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@") &&
141 w_tree=$(git rev-parse --verify "$s:") &&
cbeaccc3
JH
142 b_tree=$(git rev-parse --verify "$s^1:") &&
143 i_tree=$(git rev-parse --verify "$s^2:") ||
f2c66ed1
NS
144 die "$*: no valid stashed state found"
145
cbeaccc3
JH
146 unstashed_index_tree=
147 if test -n "$unstash_index" && test "$b_tree" != "$i_tree"
148 then
150937c4
JS
149 git diff --binary $s^2^..$s^2 | git apply --cached
150 test $? -ne 0 &&
151 die 'Conflicts in index. Try without --index.'
152 unstashed_index_tree=$(git-write-tree) ||
153 die 'Could not save index tree'
154 git reset
cbeaccc3 155 fi
150937c4 156
f2c66ed1
NS
157 eval "
158 GITHEAD_$w_tree='Stashed changes' &&
159 GITHEAD_$c_tree='Updated upstream' &&
160 GITHEAD_$b_tree='Version stash was based on' &&
161 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
162 "
163
164 if git-merge-recursive $b_tree -- $c_tree $w_tree
165 then
166 # No conflict
cbeaccc3
JH
167 if test -n "$unstashed_index_tree"
168 then
169 git read-tree "$unstashed_index_tree"
83b3df7d
JH
170 else
171 a="$TMP-added" &&
172 git diff --cached --name-only --diff-filter=A $c_tree >"$a" &&
173 git read-tree --reset $c_tree &&
174 git update-index --add --stdin <"$a" ||
175 die "Cannot unstage modified files"
176 rm -f "$a"
cbeaccc3
JH
177 fi
178 git status || :
f2c66ed1
NS
179 else
180 # Merge conflict; keep the exit status from merge-recursive
150937c4 181 status=$?
cbeaccc3
JH
182 if test -n "$unstash_index"
183 then
184 echo >&2 'Index was not unstashed.'
185 fi
150937c4 186 exit $status
f2c66ed1
NS
187 fi
188}
189
190# Main command set
191case "$1" in
fcb10a96
JH
192list)
193 shift
f2c66ed1
NS
194 if test $# = 0
195 then
196 set x -n 10
197 shift
198 fi
199 list_stash "$@"
200 ;;
201show)
202 shift
203 show_stash "$@"
204 ;;
205apply)
206 shift
207 apply_stash "$@"
208 ;;
209clear)
210 clear_stash
211 ;;
bc9e7399
JH
212create)
213 if test $# -gt 0 && test "$1" = create
214 then
215 shift
216 fi
217 create_stash "$*" && echo "$w_commit"
218 ;;
9f62e18a
JH
219help | usage)
220 usage
f2c66ed1
NS
221 ;;
222*)
9f62e18a
JH
223 if test $# -gt 0 && test "$1" = save
224 then
225 shift
226 fi
227 save_stash "$*" && git-reset --hard
228 ;;
f2c66ed1 229esac